﻿using System;
using System.Windows.Forms;
using System.Configuration;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace Edge
{
    public partial class Main : Form
    {
        [DllImport("user32")] private static extern bool SetForegroundWindow(IntPtr hWnd);
        private string DataInput = "";
        private string LastInput = "";
        private string Naem = ConfigurationManager.AppSettings["Name"];
        private string Data = ConfigurationManager.AppSettings["Data"];
        private int Wait = int.Parse(ConfigurationManager.AppSettings["Wait"]);
        private int Ping = int.Parse(ConfigurationManager.AppSettings["Ping"]);
        private int Type = int.Parse(ConfigurationManager.AppSettings["Type"]);

        public Main()
        {
            InitializeComponent();
        }

        private void Paste()
        {
            SendKeys.SendWait("^v");
            SendKeys.Send("~");
        }

        private void Checking()
        {
            SendKeys.Send(Data);
        }

        private void Main_Load(object sender, EventArgs e)
        {
            PasteSN.Interval = Wait;
            Check.Interval = Ping;
        }

        private void Main_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar >= 48 && e.KeyChar <= 58 || e.KeyChar >= 65 && e.KeyChar <= 90 || e.KeyChar >= 97 && e.KeyChar <= 122)
            {
                DataInput += e.KeyChar;
            }
            if (e.KeyChar == (char)Keys.Enter)
            {
                DataInput = DataInput.ToUpper();
                if (DataInput.StartsWith("AUG:"))
                {
                    DataInput = DataInput.Substring(4);
                }
                if (!DataInput.StartsWith("0810") && DataInput.Length > 9)
                {
                    LastInput = DataInput;
                    Clipboard.SetText(LastInput);
                    PasteSN.Enabled = true;
                }
                DataInput = "";
            }
        }

        private void PasteSN_Tick(object sender, EventArgs e)
        {
            Process[] processes = Process.GetProcesses();
            foreach (Process process in processes)
            {
                if (process.MainWindowTitle.Contains(Naem))
                {
                    SetForegroundWindow(process.MainWindowHandle);
                    if (Type > 0)
                    {
                        Paste();
                    }
                    else
                    {
                        Checking();
                    }
                    Check.Enabled = true;
                    break;
                }
            }
            PasteSN.Enabled = false;
        }

        private void Check_Tick(object sender, EventArgs e)
        {
            if (Type > 0)
            {
                Checking();
            }
            else
            {
                Paste();
            }
            SetForegroundWindow(Process.GetCurrentProcess().MainWindowHandle);
            Check.Enabled = false;
        }
    }
}
